package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceCalibrationPeriod;
import pps.core.space.entity.SpaceCalibrationPeriodView;
import pps.core.space.mapper.SpaceCalibrationPeriodMapper;
import pps.core.space.mapper.SpaceCalibrationPeriodViewMapper;
import pps.core.space.service.data.space_calibration_period.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceCalibrationPeriodService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceCalibrationPeriod(XContext context, CreateSpaceCalibrationPeriodInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        SpaceCalibrationPeriod entity = new SpaceCalibrationPeriod();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceCalibrationPeriod(XContext context, UpdateSpaceCalibrationPeriodInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        QueryWrapper<SpaceCalibrationPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceCalibrationPeriod::getId, input.getId());
        SpaceCalibrationPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceCalibrationPeriod(XContext context, DeleteSpaceCalibrationPeriodInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        QueryWrapper<SpaceCalibrationPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceCalibrationPeriod::getId, input.getId());
        SpaceCalibrationPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceCalibrationPeriodOutput> getSpaceCalibrationPeriod(XContext context, GetSpaceCalibrationPeriodInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        QueryWrapper<SpaceCalibrationPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceCalibrationPeriod::getId, input.getId());
        SpaceCalibrationPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceCalibrationPeriodOutput output = new GetSpaceCalibrationPeriodOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceCalibrationPeriodOutput> querySpaceCalibrationPeriod(XContext context, QuerySpaceCalibrationPeriodInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        QueryWrapper<SpaceCalibrationPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceCalibrationPeriod::getId, input.getId())
                .eq(SpaceCalibrationPeriod::getIsDeleted, input.getIsDeleted())
                .like(SpaceCalibrationPeriod::getCreateById, input.getCreateById())
                .like(SpaceCalibrationPeriod::getCreateByName, input.getCreateByName())
                .eq(SpaceCalibrationPeriod::getCreateTime, input.getCreateTime())
                .like(SpaceCalibrationPeriod::getModifyById, input.getModifyById())
                .like(SpaceCalibrationPeriod::getModifyByName, input.getModifyByName())
                .eq(SpaceCalibrationPeriod::getModifyTime, input.getModifyTime())
                .like(SpaceCalibrationPeriod::getLineId, input.getLineId())
                .like(SpaceCalibrationPeriod::getDayNumber, input.getDayNumber());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceCalibrationPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceCalibrationPeriodOutput> dynamicQuerySpaceCalibrationPeriod(XContext context, CustomQueryInput input) {
        SpaceCalibrationPeriodMapper mapper = context.getBean(SpaceCalibrationPeriodMapper.class);
        return XMapperHelper.query(mapper, input, SpaceCalibrationPeriod.class, QuerySpaceCalibrationPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceCalibrationPeriodViewOutput> getSpaceCalibrationPeriodView(XContext context, GetSpaceCalibrationPeriodViewInput input) {
        SpaceCalibrationPeriodViewMapper mapper = context.getBean(SpaceCalibrationPeriodViewMapper.class);
        SpaceCalibrationPeriodView record = new SpaceCalibrationPeriodView();
        XCopyUtils.copyObject(input, record);
        SpaceCalibrationPeriodView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceCalibrationPeriodViewOutput output = new GetSpaceCalibrationPeriodViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceCalibrationPeriodViewOutput> querySpaceCalibrationPeriodView(XContext context, QuerySpaceCalibrationPeriodViewInput input) {
        SpaceCalibrationPeriodViewMapper mapper = context.getBean(SpaceCalibrationPeriodViewMapper.class);
        SpaceCalibrationPeriodView record = new SpaceCalibrationPeriodView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceCalibrationPeriodView> list = mapper.selectList(record);
        PageInfo<SpaceCalibrationPeriodView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceCalibrationPeriodViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceCalibrationPeriodViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
