package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeLongWellhead;
import pps.core.space.entity.SpaceOptimizeLongWellheadView;
import pps.core.space.mapper.SpaceOptimizeLongWellheadMapper;
import pps.core.space.mapper.SpaceOptimizeLongWellheadViewMapper;
import pps.core.space.service.data.space_optimize_long_wellhead.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeLongWellheadService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeLongWellhead(XContext context, CreateSpaceOptimizeLongWellheadInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        SpaceOptimizeLongWellhead entity = new SpaceOptimizeLongWellhead();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeLongWellhead(XContext context, UpdateSpaceOptimizeLongWellheadInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        QueryWrapper<SpaceOptimizeLongWellhead> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongWellhead::getId, input.getId());
        SpaceOptimizeLongWellhead entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeLongWellhead(XContext context, DeleteSpaceOptimizeLongWellheadInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        QueryWrapper<SpaceOptimizeLongWellhead> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongWellhead::getId, input.getId());
        SpaceOptimizeLongWellhead entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongWellheadOutput> getSpaceOptimizeLongWellhead(XContext context, GetSpaceOptimizeLongWellheadInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        QueryWrapper<SpaceOptimizeLongWellhead> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongWellhead::getId, input.getId());
        SpaceOptimizeLongWellhead entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongWellheadOutput output = new GetSpaceOptimizeLongWellheadOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongWellheadOutput> querySpaceOptimizeLongWellhead(XContext context, QuerySpaceOptimizeLongWellheadInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        QueryWrapper<SpaceOptimizeLongWellhead> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeLongWellhead::getId, input.getId())
                .eq(SpaceOptimizeLongWellhead::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeLongWellhead::getCreateById, input.getCreateById())
                .like(SpaceOptimizeLongWellhead::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeLongWellhead::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeLongWellhead::getModifyById, input.getModifyById())
                .like(SpaceOptimizeLongWellhead::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeLongWellhead::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeLongWellhead::getLongPeriodId, input.getLongPeriodId())
                .like(SpaceOptimizeLongWellhead::getWellheadId, input.getWellheadId())
                .like(SpaceOptimizeLongWellhead::getWellNumber, input.getWellNumber());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeLongWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongWellheadOutput> dynamicQuerySpaceOptimizeLongWellhead(XContext context, CustomQueryInput input) {
        SpaceOptimizeLongWellheadMapper mapper = context.getBean(SpaceOptimizeLongWellheadMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeLongWellhead.class, QuerySpaceOptimizeLongWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongWellheadViewOutput> getSpaceOptimizeLongWellheadView(XContext context, GetSpaceOptimizeLongWellheadViewInput input) {
        SpaceOptimizeLongWellheadViewMapper mapper = context.getBean(SpaceOptimizeLongWellheadViewMapper.class);
        SpaceOptimizeLongWellheadView record = new SpaceOptimizeLongWellheadView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeLongWellheadView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongWellheadViewOutput output = new GetSpaceOptimizeLongWellheadViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongWellheadViewOutput> querySpaceOptimizeLongWellheadView(XContext context, QuerySpaceOptimizeLongWellheadViewInput input) {
        SpaceOptimizeLongWellheadViewMapper mapper = context.getBean(SpaceOptimizeLongWellheadViewMapper.class);
        SpaceOptimizeLongWellheadView record = new SpaceOptimizeLongWellheadView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeLongWellheadView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeLongWellheadView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeLongWellheadViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeLongWellheadViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
