package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeMidDuration;
import pps.core.space.entity.SpaceOptimizeMidDurationView;
import pps.core.space.mapper.SpaceOptimizeMidDurationMapper;
import pps.core.space.mapper.SpaceOptimizeMidDurationViewMapper;
import pps.core.space.service.data.space_optimize_mid_duration.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeMidDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeMidDuration(XContext context, CreateSpaceOptimizeMidDurationInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        SpaceOptimizeMidDuration entity = new SpaceOptimizeMidDuration();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeMidDuration(XContext context, UpdateSpaceOptimizeMidDurationInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDuration::getId, input.getId());
        SpaceOptimizeMidDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeMidDuration(XContext context, DeleteSpaceOptimizeMidDurationInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDuration::getId, input.getId());
        SpaceOptimizeMidDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidDurationOutput> getSpaceOptimizeMidDuration(XContext context, GetSpaceOptimizeMidDurationInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDuration::getId, input.getId());
        SpaceOptimizeMidDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidDurationOutput output = new GetSpaceOptimizeMidDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationOutput> querySpaceOptimizeMidDuration(XContext context, QuerySpaceOptimizeMidDurationInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeMidDuration::getId, input.getId())
                .eq(SpaceOptimizeMidDuration::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeMidDuration::getCreateById, input.getCreateById())
                .like(SpaceOptimizeMidDuration::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeMidDuration::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeMidDuration::getModifyById, input.getModifyById())
                .like(SpaceOptimizeMidDuration::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeMidDuration::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeMidDuration::getRecordId, input.getRecordId())
                .like(SpaceOptimizeMidDuration::getMidPeriodId, input.getMidPeriodId())
                .like(SpaceOptimizeMidDuration::getWellheadId, input.getWellheadId())
                .eq(SpaceOptimizeMidDuration::getIsOptimize, input.getIsOptimize())
                .like(SpaceOptimizeMidDuration::getGenerationTypeKey, input.getGenerationTypeKey())
                .like(SpaceOptimizeMidDuration::getOpenWellTime, input.getOpenWellTime())
                .like(SpaceOptimizeMidDuration::getCloseWellTime, input.getCloseWellTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeMidDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationOutput> dynamicQuerySpaceOptimizeMidDuration(XContext context, CustomQueryInput input) {
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeMidDuration.class, QuerySpaceOptimizeMidDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidDurationViewOutput> getSpaceOptimizeMidDurationView(XContext context, GetSpaceOptimizeMidDurationViewInput input) {
        SpaceOptimizeMidDurationViewMapper mapper = context.getBean(SpaceOptimizeMidDurationViewMapper.class);
        SpaceOptimizeMidDurationView record = new SpaceOptimizeMidDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeMidDurationView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidDurationViewOutput output = new GetSpaceOptimizeMidDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationViewOutput> querySpaceOptimizeMidDurationView(XContext context, QuerySpaceOptimizeMidDurationViewInput input) {
        SpaceOptimizeMidDurationViewMapper mapper = context.getBean(SpaceOptimizeMidDurationViewMapper.class);
        SpaceOptimizeMidDurationView record = new SpaceOptimizeMidDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeMidDurationView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeMidDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeMidDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeMidDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
