package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeShortDuration;
import pps.core.space.entity.SpaceOptimizeShortDurationView;
import pps.core.space.mapper.SpaceOptimizeShortDurationMapper;
import pps.core.space.mapper.SpaceOptimizeShortDurationViewMapper;
import pps.core.space.service.data.space_optimize_short_duration.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeShortDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeShortDuration(XContext context, CreateSpaceOptimizeShortDurationInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        SpaceOptimizeShortDuration entity = new SpaceOptimizeShortDuration();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeShortDuration(XContext context, UpdateSpaceOptimizeShortDurationInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        QueryWrapper<SpaceOptimizeShortDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortDuration::getId, input.getId());
        SpaceOptimizeShortDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeShortDuration(XContext context, DeleteSpaceOptimizeShortDurationInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        QueryWrapper<SpaceOptimizeShortDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortDuration::getId, input.getId());
        SpaceOptimizeShortDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortDurationOutput> getSpaceOptimizeShortDuration(XContext context, GetSpaceOptimizeShortDurationInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        QueryWrapper<SpaceOptimizeShortDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortDuration::getId, input.getId());
        SpaceOptimizeShortDuration entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortDurationOutput output = new GetSpaceOptimizeShortDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortDurationOutput> querySpaceOptimizeShortDuration(XContext context, QuerySpaceOptimizeShortDurationInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        QueryWrapper<SpaceOptimizeShortDuration> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeShortDuration::getId, input.getId())
                .eq(SpaceOptimizeShortDuration::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeShortDuration::getCreateById, input.getCreateById())
                .like(SpaceOptimizeShortDuration::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeShortDuration::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeShortDuration::getModifyById, input.getModifyById())
                .like(SpaceOptimizeShortDuration::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeShortDuration::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeShortDuration::getRecordId, input.getRecordId())
                .like(SpaceOptimizeShortDuration::getShortPeriodId, input.getShortPeriodId())
                .like(SpaceOptimizeShortDuration::getWellheadId, input.getWellheadId())
                .eq(SpaceOptimizeShortDuration::getIsOptimize, input.getIsOptimize())
                .like(SpaceOptimizeShortDuration::getGenerationTypeKey, input.getGenerationTypeKey())
                .like(SpaceOptimizeShortDuration::getOpenWellTime, input.getOpenWellTime())
                .like(SpaceOptimizeShortDuration::getCloseWellTime, input.getCloseWellTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeShortDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortDurationOutput> dynamicQuerySpaceOptimizeShortDuration(XContext context, CustomQueryInput input) {
        SpaceOptimizeShortDurationMapper mapper = context.getBean(SpaceOptimizeShortDurationMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeShortDuration.class, QuerySpaceOptimizeShortDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortDurationViewOutput> getSpaceOptimizeShortDurationView(XContext context, GetSpaceOptimizeShortDurationViewInput input) {
        SpaceOptimizeShortDurationViewMapper mapper = context.getBean(SpaceOptimizeShortDurationViewMapper.class);
        SpaceOptimizeShortDurationView record = new SpaceOptimizeShortDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeShortDurationView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortDurationViewOutput output = new GetSpaceOptimizeShortDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortDurationViewOutput> querySpaceOptimizeShortDurationView(XContext context, QuerySpaceOptimizeShortDurationViewInput input) {
        SpaceOptimizeShortDurationViewMapper mapper = context.getBean(SpaceOptimizeShortDurationViewMapper.class);
        SpaceOptimizeShortDurationView record = new SpaceOptimizeShortDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeShortDurationView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeShortDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeShortDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeShortDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
