package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeShortPeriod;
import pps.core.space.entity.SpaceOptimizeShortPeriodView;
import pps.core.space.mapper.SpaceOptimizeShortPeriodMapper;
import pps.core.space.mapper.SpaceOptimizeShortPeriodViewMapper;
import pps.core.space.service.data.space_optimize_short_period.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeShortPeriodService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeShortPeriod(XContext context, CreateSpaceOptimizeShortPeriodInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        SpaceOptimizeShortPeriod entity = new SpaceOptimizeShortPeriod();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeShortPeriod(XContext context, UpdateSpaceOptimizeShortPeriodInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        QueryWrapper<SpaceOptimizeShortPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortPeriod::getId, input.getId());
        SpaceOptimizeShortPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeShortPeriod(XContext context, DeleteSpaceOptimizeShortPeriodInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        QueryWrapper<SpaceOptimizeShortPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortPeriod::getId, input.getId());
        SpaceOptimizeShortPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortPeriodOutput> getSpaceOptimizeShortPeriod(XContext context, GetSpaceOptimizeShortPeriodInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        QueryWrapper<SpaceOptimizeShortPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortPeriod::getId, input.getId());
        SpaceOptimizeShortPeriod entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortPeriodOutput output = new GetSpaceOptimizeShortPeriodOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortPeriodOutput> querySpaceOptimizeShortPeriod(XContext context, QuerySpaceOptimizeShortPeriodInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        QueryWrapper<SpaceOptimizeShortPeriod> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeShortPeriod::getId, input.getId())
                .eq(SpaceOptimizeShortPeriod::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeShortPeriod::getCreateById, input.getCreateById())
                .like(SpaceOptimizeShortPeriod::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeShortPeriod::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeShortPeriod::getModifyById, input.getModifyById())
                .like(SpaceOptimizeShortPeriod::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeShortPeriod::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeShortPeriod::getLineId, input.getLineId())
                .like(SpaceOptimizeShortPeriod::getInstitutionId, input.getInstitutionId())
                .eq(SpaceOptimizeShortPeriod::getOptimizeState, input.getOptimizeState())
                .eq(SpaceOptimizeShortPeriod::getOptimizeDate, input.getOptimizeDate());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeShortPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortPeriodOutput> dynamicQuerySpaceOptimizeShortPeriod(XContext context, CustomQueryInput input) {
        SpaceOptimizeShortPeriodMapper mapper = context.getBean(SpaceOptimizeShortPeriodMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeShortPeriod.class, QuerySpaceOptimizeShortPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortPeriodViewOutput> getSpaceOptimizeShortPeriodView(XContext context, GetSpaceOptimizeShortPeriodViewInput input) {
        SpaceOptimizeShortPeriodViewMapper mapper = context.getBean(SpaceOptimizeShortPeriodViewMapper.class);
        SpaceOptimizeShortPeriodView record = new SpaceOptimizeShortPeriodView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeShortPeriodView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortPeriodViewOutput output = new GetSpaceOptimizeShortPeriodViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortPeriodViewOutput> querySpaceOptimizeShortPeriodView(XContext context, QuerySpaceOptimizeShortPeriodViewInput input) {
        SpaceOptimizeShortPeriodViewMapper mapper = context.getBean(SpaceOptimizeShortPeriodViewMapper.class);
        SpaceOptimizeShortPeriodView record = new SpaceOptimizeShortPeriodView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeShortPeriodView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeShortPeriodView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeShortPeriodViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeShortPeriodViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
